/***************************************************************************
 *   Copyright (C) 2005 by s4kk3                                           *
 *   s4kk33@gmail.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "dialog.h"

/*
//
	This needs some cleaning
//
*/

using namespace std;

string Dialog::setDefaultRunAction( const string& mime, const string& homeDir )
{
	string actionsFile = homeDir + (string)"/.gbrowser/actions";
	
	string lab = "Set default run action for mimetype " + mime;
	
	GtkWidget *entry, *box, *label, *toggle;
	int ret;

	GtkWidget *dialog = gtk_dialog_new_with_buttons ("Set default run action",
		NULL,
		(GtkDialogFlags)(GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT),
		GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		NULL);

	entry = gtk_entry_new();
	box = gtk_hbox_new(false, 5);
	label = gtk_label_new(lab.c_str());
	toggle = gtk_check_button_new_with_label("Needs terminal");
	gtk_box_pack_start(GTK_BOX(box), label, TRUE, TRUE, 5);
	gtk_box_pack_start(GTK_BOX(box), entry, TRUE, TRUE, 5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), box, TRUE, TRUE, 5);
	
	box = gtk_hbox_new(false, 5);
	gtk_box_pack_start(GTK_BOX(box), toggle, TRUE, TRUE, 5);
	gtk_box_set_child_packing(GTK_BOX(box),
                              toggle,
                              false,
                              false,
                              5,
                              GTK_PACK_END);
	gtk_widget_set_size_request(toggle,
                                155,
                                -1);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), box, TRUE, TRUE, 5);
	gtk_widget_show_all(dialog);

	ret = gtk_dialog_run(GTK_DIALOG(dialog));
	string runAction = gtk_entry_get_text(GTK_ENTRY(entry));
	gboolean needsTerminal = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(toggle));
	gtk_widget_destroy(dialog);
	if (ret != GTK_RESPONSE_ACCEPT) return "";
	
	bool found;
	string exec = runAction.substr(0, runAction.find(" ", 0));
	
	found = g_file_test(exec.c_str(), (GFileTest)(G_FILE_TEST_EXISTS | G_FILE_TEST_IS_EXECUTABLE));
	
	if( !found )
	{
		const char *exe	=	g_find_program_in_path( exec.c_str() );
		if( exe == NULL ) 
			found	=	false;
		else 
			found	=	true;
	}
		
	if( !found )
	{
		Dialog::executableNotFound( exec );
		return "";
	}
	
	GKeyFile* actions	=	g_key_file_new();
	
	g_key_file_load_from_file( actions,	actionsFile.c_str(),	G_KEY_FILE_NONE,	NULL );
	
	if( runAction[ runAction.size() - 1 ]	==	' ' ) 
		runAction	=	runAction.substr( 0,	runAction.size() - 1 );
	
	g_key_file_set_string( actions,	mime.c_str(),	"Default",	runAction.c_str() );
	g_key_file_set_boolean( actions,	mime.c_str(),	runAction.c_str(),	needsTerminal );
	
	ofstream val( actionsFile.c_str() );
	char *v	=	g_key_file_to_data( actions,	NULL,	NULL );
	val	<<	v;
	val.close();
	
	g_free( v );
	g_key_file_free( actions );
	
	return runAction;
}

bool Dialog::fileExists( const string& name )
{
	GtkWidget *box, *label;
	string target, lab;
	int ret;

	lab = name + " already exists. Do you want to overwrite it?";

	GtkWidget *dialog = gtk_dialog_new_with_buttons (name.c_str(),
		NULL,
		(GtkDialogFlags)(GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT),
		GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		NULL);

	box = gtk_hbox_new(false, 5);
	label = gtk_label_new(lab.c_str());
	
	gtk_box_pack_start(GTK_BOX(box), label, TRUE, TRUE, 5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), box, TRUE, TRUE, 5);
	gtk_widget_show_all(dialog);

	ret = gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);
	if (ret != GTK_RESPONSE_ACCEPT) return false;

	return true;
}

std::string Dialog::createNewFuncDialog( const string& lab, const string& name, const string& text, 
					 const string& currentDir, bool prependPath )
{
	GtkWidget *entry,	*box,	*label;
	string target,	cmd,	separator = "/",	dir = currentDir;
	int ret;

	GtkWidget *dialog	=	gtk_dialog_new_with_buttons ( name.c_str(),
			NULL,
			(GtkDialogFlags)( GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT ),
			GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
			GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
			NULL );

	entry	=	gtk_entry_new();
	box		=	gtk_hbox_new(false, 5);
	label		=	gtk_label_new(lab.c_str());
	 
	gtk_box_pack_start( GTK_BOX( box ),	label,	TRUE,	TRUE,	5 );
	gtk_box_pack_start( GTK_BOX( box ),	entry,	TRUE,	TRUE,	5 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( dialog )->vbox ),	box,	TRUE,	TRUE,	5 );
	
	gtk_entry_set_text( GTK_ENTRY( entry ),	text.c_str() );
	
	gtk_widget_show_all( dialog );

	ret		=	gtk_dialog_run( GTK_DIALOG( dialog ) );
	target	=	gtk_entry_get_text( GTK_ENTRY( entry ) );
	
	gtk_widget_destroy( dialog );
	
	if( ret	!=	GTK_RESPONSE_ACCEPT ) 
		return "";
	
	if( g_str_has_prefix( target.c_str(),	"/" ) )
	{
		dir		=	"";
		separator	=	"";
	}

	string path;
	
	if( prependPath )
		path	=	dir + separator + target;
	else 
		path	=	target;
	
	return path;
}

void Dialog::noPermissions( const string& path )
{
	GtkWidget *box, *label, *dialog;
	string text = "You don't have write permissions in " + path;
	
	dialog = gtk_dialog_new_with_buttons ("No Permissions",
                                                  NULL,
                                                  GTK_DIALOG_MODAL,
                                                  GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
                                                  NULL);
	box = gtk_hbox_new(false, 5);
	label = gtk_label_new(text.c_str());
	gtk_box_pack_start(GTK_BOX(box), label, TRUE, TRUE, 5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), box, TRUE, TRUE, 5);
	gtk_widget_show_all(dialog);
	
	gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);
}

void Dialog::executableNotFound( const string& executable )
{
	GtkWidget *box, *label, *dialog;
	string text = "Can't find " + executable + (string)" .\nMaybe it isn't in your $PATH environment variable";
	
	dialog = gtk_dialog_new_with_buttons ("Executable not found",
                                                  NULL,
                                                  GTK_DIALOG_MODAL,
                                                  GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
                                                  NULL);
	box = gtk_hbox_new(false, 5);
	label = gtk_label_new(text.c_str());
	gtk_box_pack_start(GTK_BOX(box), label, TRUE, TRUE, 5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), box, TRUE, TRUE, 5);
	gtk_widget_show_all(dialog);
	
	gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);
}

void Dialog::dialogWithTextEntry( const string& title, const string& content )
{
	GtkWidget *box,	*entry,	*dialog,	*win;
	GtkTextBuffer	*buf;
	GtkTextTagTable *table;
	
	dialog	=	gtk_dialog_new_with_buttons ( title.c_str(),
							NULL,
							GTK_DIALOG_MODAL,
							GTK_STOCK_CLOSE, GTK_RESPONSE_ACCEPT,
							NULL );

	win		=	gtk_scrolled_window_new( false,	false );
	box		=	gtk_hbox_new( false,	5 );
	table		=	gtk_text_tag_table_new();
	buf		=	gtk_text_buffer_new( table );
	entry		=	gtk_text_view_new_with_buffer( buf );
	
	gtk_widget_set_size_request( win,	300,	400 );

	gtk_container_add( GTK_CONTAINER( win ),	entry );

	gtk_text_buffer_set_text( buf,	content.c_str(),	content.size() );
	
	gtk_box_pack_start( GTK_BOX( box ),	win,	TRUE,	TRUE,	5 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( dialog )->vbox ),	box,	TRUE,	TRUE,	5 );
	gtk_widget_show_all( dialog );
	
	gtk_dialog_run( GTK_DIALOG( dialog ) );
	gtk_widget_destroy( dialog );	
}

bool Dialog::confirmDialog( const string& title, const string& content )
{
	GtkWidget *box,	*label,	*dialog;
	
	dialog	=	gtk_dialog_new_with_buttons ( title.c_str(),
                                                  NULL,
                                                  GTK_DIALOG_MODAL,
                                                  GTK_STOCK_OK,		GTK_RESPONSE_ACCEPT,
						  GTK_STOCK_CANCEL,	GTK_RESPONSE_CANCEL,
                                                  NULL );
	box	=	gtk_hbox_new( false,	5 );
	label	=	gtk_label_new( content.c_str() );
	
	gtk_box_pack_start( GTK_BOX( box ),	label,	TRUE,	TRUE,	5 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( dialog )->vbox ),	box,	TRUE,	TRUE,	5 );
	gtk_widget_show_all( dialog );
	
	int ret	=	gtk_dialog_run( GTK_DIALOG( dialog ) );
	gtk_widget_destroy( dialog );	

	if( ret	==	GTK_RESPONSE_ACCEPT )
		return true;
	return false;
}
