/***************************************************************************
 *   Copyright (C) 2005 by s4kk3   										   *
 *   s4kk33@gmail.com   												   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FILEINFO_H
#define FILEINFO_H

#include "mainwindow.h"
#include "fileview.h"

class FileInfo
{
public:
	static FileInfo 	*getInstance( FileView *fv	=	NULL );
	~FileInfo();
	
	void	setEntry			( std::string path );
	void	cancelClicked		( GtkWidget *widget,	gpointer data );
	void	okClicked			( GtkWidget *widget,	gpointer data );
	void	setActionClicked	( GtkWidget *widget,	gpointer data );
	void	onDestroyEvent	( GtkWidget *widget,	gpointer data );
#if ENABLE_EXIF
	void	setExifData		( const std::string& file );
#endif
	
protected:
	FileView	*fv;
	MainWindow	*mw;
	
	GtkWidget	*window;
	GtkNotebook	*infoBook,	*fileBook;
	GtkLabel		*locationLabel,	*mimeLabel,	*sizeLabel,	*exactSizeLabel,	*runActionLabel;
	GtkButton	*actionButton,	*okButton,	*cancelButton;
	GtkImage		*fileIcon;
	GtkEntry		*nameEntry;

	std::map<GtkEntry *, std::string> entryList;
	
	Func2<FileInfo, void, GtkWidget*> cancelCallback,	okCallback,	actionCallback,	destroyCallback;

private:
	FileInfo( FileView *f );
	static FileInfo	*info;
};

#else
class FileInfo;
#endif
