/***************************************************************************
 *   Copyright (C) 2005 by s4kk3   										   *
 *   s4kk33@gmail.com   												   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef FUNC_H
#define FUNC_H

template<class C, typename Ret, typename P1>
class Func2
{
public:
	Func2()	{};

	void	connect( GObject *obj,	std::string signal,	C *c, Ret ( C::*func )( P1, gpointer ),	gpointer data )
	{
		_c	=	c;
		_func	=	func;
		_data	=	data;
		g_signal_connect( obj,	signal.c_str(),	G_CALLBACK( &Func2::func ),	( void* )this );
	};

	void	connect_after( GObject *obj,	std::string signal,	C *c,	Ret ( C::*func )( P1, gpointer ),	gpointer data )
	{
		_c	=	c;
		_func	=	func;
		_data	=	data;
		g_signal_connect_after( obj,	signal.c_str(),	G_CALLBACK( &Func2::func ),	( void* )this );
	};

	static void 	func( P1 _param1,	gpointer data )
	{
		Func2<C, Ret, P1> *f	=	( Func2<C, Ret, P1> * )	data;
		f->con( _param1 );
	};

	void	con( P1 _param1 )	const	{ (*_c.*_func)( _param1,	_data ); };

private:
	C	*_c;
	Ret	( C::*_func )( P1, gpointer );
	gpointer	_data;
};

template<class C, typename Ret, typename P1, typename P2>
class Func3
{
public:
	Func3(){};

	void connect(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect(obj, signal.c_str(), G_CALLBACK(&Func3::func), (void*)this);
	};

	void connect_after(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect_after(obj, signal.c_str(), G_CALLBACK(&Func3::func), (void*)this);
	};

	void connect_swapped(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect_swapped(obj, signal.c_str(), G_CALLBACK(&Func3::func), (void*)this);
	};
		
	static void func(P1 _param1, P2 _param2, gpointer data){
		Func3<C, Ret, P1, P2> *f = (Func3<C, Ret, P1, P2> *)data;
		f->con(_param1, _param2);
	};
	
	void con(P1 _param1, P2 _param2){ (*_c.*_func)(_param1, _param2, _data); };
	
private:
	C *_c;
	Ret (C::*_func)(P1, P2, gpointer);
	gpointer _data;
};

template<class C, typename Ret, typename P1, typename P2, typename P3>
class Func4
{
public:
	Func4(){};
	
	void connect(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, P3, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect(obj, signal.c_str(), G_CALLBACK(&Func4::func), (void*)this);
	};
	
        void connect_after(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, P3, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect_after(obj, signal.c_str(), G_CALLBACK(&Func4::func), (void*)this);
	};
	
	static void func(P1 _param1, P2 _param2, P3 _param3, gpointer data){
		Func4<C, Ret, P1, P2, P3> *f = (Func4<C, Ret, P1, P2, P3> *)data;
		f->con(_param1, _param2, _param3);
	};
		
	void con(P1 _param1, P2 _param2, P3 _param3){ (*_c.*_func)(_param1, _param2, _param3, _data); };
		
private:
	C *_c;
	Ret (C::*_func)(P1, P2, P3, gpointer);
	gpointer _data;
};

template<class C, typename Ret, typename P1, typename P2, typename P3, typename P4, typename P5>
class Func6
{
public:
	Func6(){};
	
	void connect(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, P3, P4, P5, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect(obj, signal.c_str(), G_CALLBACK(&Func6::func), (void*)this);
	};
		
	void connect_after(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, P3, P4, P5, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect_after(obj, signal.c_str(), G_CALLBACK(&Func6::func), (void*)this);
	};
		
	static void func(P1 _param1, P2 _param2, P3 _param3, P4 _param4, P5 _param5, gpointer data){
		Func6<C, Ret, P1, P2, P3, P4, P5> *f = (Func6<C, Ret, P1, P2, P3, P4, P5> *)data;
		f->con(_param1, _param2, _param3, _param4, _param5);
	};
		
	void con(P1 _param1, P2 _param2, P3 _param3, P4 _param4, P5 _param5){ 
		(*_c.*_func)(_param1, _param2, _param3, _param4, _param5, _data); };
	
private:
	C *_c;
	Ret (C::*_func)(P1, P2, P3, P4, P5, gpointer);
	gpointer _data;
};

template<class C, typename Ret, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7>
class Func8
{
public:
	Func8(){};
	
	void connect(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, P3, P4, P5, P6, P7, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect(obj, signal.c_str(), G_CALLBACK(&Func8::func), (void*)this);
	};
	
	void connect_after(GObject *obj, std::string signal, C *c, Ret (C::*func)(P1, P2, P3, P4, P5, P6, P7, gpointer), gpointer data){
		_c = c;
		_func = func;
		_data = data;
		g_signal_connect_after(obj, signal.c_str(), G_CALLBACK(&Func8::func), (void*)this);
	};
	
	static void func(P1 _param1, P2 _param2, P3 _param3, P4 _param4, P5 _param5, P6 _param6, P7 _param7, gpointer data){
		Func8<C, Ret, P1, P2, P3, P4, P5, P6, P7> *f = (Func8<C, Ret, P1, P2, P3, P4, P5, P6, P7> *)data;
		f->con(_param1, _param2, _param3, _param4, _param5, _param6, _param7);
	};
	
	void con(P1 _param1, P2 _param2, P3 _param3, P4 _param4, P5 _param5, P6 _param6, P7 _param7){ 
		(*_c.*_func)(_param1, _param2, _param3, _param4, _param5, _param6, _param7, _data);		
	};
		
private:
	C *_c;
	Ret (C::*_func)(P1, P2, P3, P4, P5, P6, P7, gpointer);
	gpointer _data;
};

#else
template<class C, typename Ret, typename P1>
class Func2;
template<class C, typename Ret, typename P1, typename P2>
class Func3;
template<class C, typename Ret, typename P1, typename P2, typename P3>
class Func4;
template<class C, typename Ret, typename P1, typename P2, typename P3, typename P4, typename P5>
class Func6;
template<class C, typename Ret, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename P7>
class Func8;
#endif
