/***************************************************************************
 *   Copyright (C) 2005 by s4kk3	                                                                          *
 *   s4kk33@gmail.com                                                                                              *
 *                                                                                                                                *
 *   This program is free software; you can redistribute it and/or modify	           *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef THUMBNAIL_H
#define THUMBNAIL_H

#include "mainwindow.h"
#include <gdk-pixbuf/gdk-pixbuf-core.h>

class Thumbnail
{
public:
	static	Thumbnail	*getInstance();
	~Thumbnail();

	GdkPixbuf	*getThumbnailAtSize		( std::string path, int size )	const;
	GdkPixbuf	*getThumbnailFromDatabase	( GtkListStore *store, GtkTreeIter iter, std::string path, int size );
	GdkPixbuf	*getThumbnail			( std::string name, int size )	const;
	
	bool	compareThumbnails		( std::string originalFile,	std::string thumbFile,	int size );
		
	void	saveThumbnailToFile		( GdkPixbuf *buf,	std::string name )	const;

protected:
	std::string thumbDir;

	guint id;

private:
	Thumbnail();
	static Thumbnail *thumb;
};
#else
class Thumbnail;
#endif
